function _typeof(obj) { "@babel/helpers - typeof"; return _typeof = "function" == typeof Symbol && "symbol" == typeof Symbol.iterator ? function (obj) { return typeof obj; } : function (obj) { return obj && "function" == typeof Symbol && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }, _typeof(obj); }

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); enumerableOnly && (symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; })), keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = null != arguments[i] ? arguments[i] : {}; i % 2 ? ownKeys(Object(source), !0).forEach(function (key) { _defineProperty(target, key, source[key]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)) : ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } return target; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); Object.defineProperty(Constructor, "prototype", { writable: false }); return Constructor; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }); Object.defineProperty(subClass, "prototype", { writable: false }); if (superClass) _setPrototypeOf(subClass, superClass); }

function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf ? Object.setPrototypeOf.bind() : function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = _getPrototypeOf(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = _getPrototypeOf(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return _possibleConstructorReturn(this, result); }; }

function _possibleConstructorReturn(self, call) { if (call && (_typeof(call) === "object" || typeof call === "function")) { return call; } else if (call !== void 0) { throw new TypeError("Derived constructors may only return object or undefined"); } return _assertThisInitialized(self); }

function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Boolean.prototype.valueOf.call(Reflect.construct(Boolean, [], function () {})); return true; } catch (e) { return false; } }

function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf.bind() : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

import React, { Component } from 'react';
/**
 * 创建 ajax 高阶组件
 *
 * 组件卸载时，打断未完成的请求
 * props中注入ajax属性
 *
 * 使用方式：
 * this.props.ajax.get(...)
 *
 * @param ajax
 * @returns {function({propName?: *}=): function(*): WithAjax}
 */

import { jsx as _jsx } from "react/jsx-runtime";

var createAjaxHoc = function createAjaxHoc(ajax) {
  return function () {
    var _ref = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {},
        _ref$propName = _ref.propName,
        propName = _ref$propName === void 0 ? 'ajax' : _ref$propName;

    return function (WrappedComponent) {
      var _class;

      return _class = /*#__PURE__*/function (_Component) {
        _inherits(WithAjax, _Component);

        var _super = _createSuper(WithAjax);

        function WithAjax(props) {
          var _this;

          _classCallCheck(this, WithAjax);

          _this = _super.call(this, props);

          _defineProperty(_assertThisInitialized(_this), "_$ajax", void 0);

          _defineProperty(_assertThisInitialized(_this), "_$ajaxTokens", void 0);

          _this._$ajax = {};
          _this._$ajaxTokens = [];
          var methods = ['get', 'post', 'put', 'patch', 'del', 'download', 'upload'];
          methods.forEach(function (method) {
            _this._$ajax[method] = function (url, data, options) {
              var _options = options || {};

              _options.cancelRef = function (c) {
                _this._$ajaxTokens.push(c);
              };

              return ajax[method](url, data, _options);
            };
          });
          return _this;
        } // 组件卸载时，打断未完成请求


        _createClass(WithAjax, [{
          key: "componentWillUnmount",
          value: function componentWillUnmount() {
            this._$ajaxTokens.forEach(function (cancel) {
              return cancel && cancel();
            });
          }
        }, {
          key: "render",
          value: function render() {
            var props = this.props,
                _$ajax = this._$ajax;

            var injectProps = _defineProperty({}, propName, _$ajax);

            return /*#__PURE__*/_jsx(WrappedComponent, _objectSpread(_objectSpread({}, injectProps), props));
          }
        }]);

        return WithAjax;
      }(Component), _defineProperty(_class, "displayName", "WithAjax(".concat(WrappedComponent.displayName || WrappedComponent.name || 'Component', ")")), _class;
    };
  };
};

export default createAjaxHoc;