import { AxiosInstance, AxiosResponseHeaders } from 'axios';
/**
 * 多个请求共用一个loading状态， 使用 __count 作为哨兵变量
 * @param fn
 * @param loading
 */
export declare function setPublicLoading(fn: any, loading: boolean): void;
/**
 * 创建ajax实例时，进行默认值设置
 * @param defaults
 * @param instance
 */
export declare function setDefaults(defaults: any, instance: AxiosInstance): void;
/**
 * 从headers中获取文件名
 * @param headers
 * @returns {string|null}
 */
export declare function getFileName(headers: AxiosResponseHeaders | Partial<Record<string, string> & {
    'set-cookie'?: string[] | undefined;
}>): string | undefined;
/**
 * 判断是否是对象
 * @param data
 */
export declare function isObject(data: unknown): boolean;
/**
 * 对象深拷贝
 * @param data
 * @param hash
 */
export declare function cloneDeep(data: any, hash?: WeakMap<object, any>): {
    [x: string]: any;
};
/**
 * 递归处理对象
 * @param data
 * @param deal
 */
export declare function loopObject(data: {
    [x: string]: any;
}, deal: (data: {
    [x: string]: any;
}, key: PropertyKey, value: any) => any): any;
/**
 * 删除对象值为 '' null undefined 属性
 * @param data
 * @returns {*}
 */
export declare function emptyObject(data: any): any;
/**
 * 删除对象值为 '' null undefined 属性
 * @param data
 * @returns {*}
 */
export declare function setObjectUndefinedToNull(data: any): any;
/**
 * 对象字符串值 去空格
 * @param data
 * @returns {{}|*}
 */
export declare function trimObject(data: any): any;
/**
 * 从headers中获取 contentType
 * @param headers
 * @returns {*}
 */
export declare function getContentType(headers: any): any;
/**
 * 处理url中的参数 「:id」或「{id}」
 * @param url
 * @param pathParams
 * @returns {*}
 */
export declare function setUrlPathParams(url: string | undefined, pathParams: {
    [x: string]: any;
}): string | undefined;
/**
 * 修复因为从excel复制粘贴导致的特殊字符
 * @param obj
 */
export declare function fixObjectU202D(obj: any): any;
/**
 * 修复因为从excel复制粘贴导致的特殊字符
 * @param obj
 */
export declare function objectSpaceUnicodeToASCII(obj: any): any;
export declare function spaceUnicodeToASCII(str: any): any;
export declare function fixU202D(str: any): any;
