function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); enumerableOnly && (symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; })), keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = null != arguments[i] ? arguments[i] : {}; i % 2 ? ownKeys(Object(source), !0).forEach(function (key) { _defineProperty(target, key, source[key]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)) : ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } return target; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function _toConsumableArray(arr) { return _arrayWithoutHoles(arr) || _iterableToArray(arr) || _unsupportedIterableToArray(arr) || _nonIterableSpread(); }

function _nonIterableSpread() { throw new TypeError("Invalid attempt to spread non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }

function _iterableToArray(iter) { if (typeof Symbol !== "undefined" && iter[Symbol.iterator] != null || iter["@@iterator"] != null) return Array.from(iter); }

function _arrayWithoutHoles(arr) { if (Array.isArray(arr)) return _arrayLikeToArray(arr); }

function _typeof(obj) { "@babel/helpers - typeof"; return _typeof = "function" == typeof Symbol && "symbol" == typeof Symbol.iterator ? function (obj) { return typeof obj; } : function (obj) { return obj && "function" == typeof Symbol && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }, _typeof(obj); }

function _slicedToArray(arr, i) { return _arrayWithHoles(arr) || _iterableToArrayLimit(arr, i) || _unsupportedIterableToArray(arr, i) || _nonIterableRest(); }

function _nonIterableRest() { throw new TypeError("Invalid attempt to destructure non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }

function _unsupportedIterableToArray(o, minLen) { if (!o) return; if (typeof o === "string") return _arrayLikeToArray(o, minLen); var n = Object.prototype.toString.call(o).slice(8, -1); if (n === "Object" && o.constructor) n = o.constructor.name; if (n === "Map" || n === "Set") return Array.from(o); if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen); }

function _arrayLikeToArray(arr, len) { if (len == null || len > arr.length) len = arr.length; for (var i = 0, arr2 = new Array(len); i < len; i++) { arr2[i] = arr[i]; } return arr2; }

function _iterableToArrayLimit(arr, i) { var _i = arr == null ? null : typeof Symbol !== "undefined" && arr[Symbol.iterator] || arr["@@iterator"]; if (_i == null) return; var _arr = []; var _n = true; var _d = false; var _s, _e; try { for (_i = _i.call(arr); !(_n = (_s = _i.next()).done); _n = true) { _arr.push(_s.value); if (i && _arr.length === i) break; } } catch (err) { _d = true; _e = err; } finally { try { if (!_n && _i["return"] != null) _i["return"](); } finally { if (_d) throw _e; } } return _arr; }

function _arrayWithHoles(arr) { if (Array.isArray(arr)) return arr; }

/**
 * 多个请求共用一个loading状态， 使用 __count 作为哨兵变量
 * @param fn
 * @param loading
 */
export function setPublicLoading(fn, loading) {
  // 方法不存在，直接返回，啥也不错
  if (!fn) return;
  var setLoading = fn;
  if (!setLoading.__count) setLoading.__count = 0; // 设置loading为true

  if (loading) {
    setLoading(true);
    setLoading.__count += 1;
    return;
  } // 设置loading为false


  setLoading.__count -= 1;
  if (setLoading.__count === 0) setLoading(false);
}
/**
 * 创建ajax实例时，进行默认值设置
 * @param defaults
 * @param instance
 */

export function setDefaults(defaults, instance) {
  var ajaxInstance = instance;
  Object.entries(defaults).forEach(function (_ref) {
    var _ref2 = _slicedToArray(_ref, 2),
        key = _ref2[0],
        value = _ref2[1];

    // @ts-ignore
    var oldValue = ajaxInstance.defaults[key];

    if (_typeof(value) === 'object' && oldValue) {
      if (Array.isArray(value)) {
        // @ts-ignore
        ajaxInstance.defaults[key] = [].concat(_toConsumableArray(oldValue), _toConsumableArray(value));
      } else {
        // @ts-ignore
        ajaxInstance.defaults[key] = _objectSpread(_objectSpread({}, oldValue), value);
      }
    } else {
      // @ts-ignore
      ajaxInstance.defaults[key] = value;
    }
  });
}
/**
 * 从headers中获取文件名
 * @param headers
 * @returns {string|null}
 */

export function getFileName(headers) {
  if (!headers) return;
  if (headers.filename) return headers.filename;
  if (headers.fileName) return headers.fileName;
  if (headers['file-name']) return headers['file-name'];
  var contentDisposition = headers['content-disposition'];
  if (!contentDisposition) return; // 当存在 filename* 时，取filename* 并进行解码（为了解决中文乱码问题）

  if (contentDisposition.includes('filename*=')) {
    var _contentDisposition$s;

    var fileNameUnicode = (_contentDisposition$s = contentDisposition.split('filename*=')) === null || _contentDisposition$s === void 0 ? void 0 : _contentDisposition$s[1];

    if (fileNameUnicode) {
      return decodeURIComponent(fileNameUnicode.split("''")[1]);
    }
  } // 普通的fileName


  var filenameRegex = /filename[^;=\n]*=((['"]).*?\2|[^;\n]*)/;
  var matches = filenameRegex.exec(contentDisposition);

  if (matches != null && matches[1]) {
    return matches[1].replace(/['"]/g, '');
  }
}
/**
 * 判断是否是对象
 * @param data
 */

export function isObject(data) {
  if (!data) return false;
  if (_typeof(data) !== 'object') return false;
  if (typeof FormData !== 'undefined' && data instanceof FormData) return false;
  return !Array.isArray(data);
}
/**
 * 对象深拷贝
 * @param data
 * @param hash
 */

export function cloneDeep(data) {
  var hash = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : new WeakMap();

  if (_typeof(data) !== 'object' || data === null) {
    throw new TypeError('传入参数不是对象');
  } // 判断传入的待拷贝对象的引用是否存在于hash中


  if (hash.has(data)) {
    return hash.get(data);
  }

  var newData = {};
  var dataKeys = Object.keys(data);
  dataKeys.forEach(function (value) {
    var currentDataValue = data[value]; // 基本数据类型的值和函数直接赋值拷贝

    if (_typeof(currentDataValue) !== 'object' || currentDataValue === null) {
      newData[value] = currentDataValue;
    } else if (Array.isArray(currentDataValue)) {
      // 实现数组的深拷贝
      newData[value] = _toConsumableArray(currentDataValue);
    } else if (currentDataValue instanceof Set) {
      // 实现set数据的深拷贝
      // @ts-ignore
      newData[value] = new Set(_toConsumableArray(currentDataValue));
    } else if (currentDataValue instanceof Map) {
      // 实现map数据的深拷贝
      // @ts-ignore
      newData[value] = new Map(_toConsumableArray(currentDataValue));
    } else {
      // 将这个待拷贝对象的引用存于hash中
      hash.set(data, data); // 普通对象则递归赋值

      newData[value] = cloneDeep(currentDataValue, hash);
    }
  });
  return newData;
}
/**
 * 递归处理对象
 * @param data
 * @param deal
 */

export function loopObject(data, deal) {
  if (typeof FormData !== 'undefined' && data instanceof FormData) return data;
  if (_typeof(data) !== 'object') return data;
  if (data === null) return data;
  if (Array.isArray(data)) return data.map(function (d) {
    return loopObject(d, deal);
  });
  var newData = cloneDeep(data);
  Object.entries(newData).forEach(function (_ref3) {
    var _ref4 = _slicedToArray(_ref3, 2),
        key = _ref4[0],
        value = _ref4[1];

    if (_typeof(value) === 'object') return newData[key] = loopObject(value, deal);
    deal(newData, key, value);
  }, {});
  return newData;
}
/**
 * 删除对象值为 '' null undefined 属性
 * @param data
 * @returns {*}
 */

export function emptyObject(data) {
  return loopObject(data, function (_data, key, value) {
    if (['', null, undefined].includes(value)) {
      Reflect.deleteProperty(_data, key);
    }
  });
}
/**
 * 删除对象值为 '' null undefined 属性
 * @param data
 * @returns {*}
 */

export function setObjectUndefinedToNull(data) {
  return loopObject(data, function (_data, key, value) {
    if ([undefined].includes(value)) {
      // @ts-ignore
      _data[key] = null;
    }
  });
}
/**
 * 对象字符串值 去空格
 * @param data
 * @returns {{}|*}
 */

export function trimObject(data) {
  return loopObject(data, function (_data, key, value) {
    // @ts-ignore
    _data[key] = typeof value === 'string' ? value.trim() : value;
  });
}
/**
 * 从headers中获取 contentType
 * @param headers
 * @returns {*}
 */

export function getContentType(headers) {
  if (!headers || _typeof(headers) !== 'object') return; // content-type 可能多种传参方式，做个兼容

  var contentTypeKeys = ['Content-Type', 'content-type', 'contentType'];
  var key = contentTypeKeys.find(function (k) {
    return !!headers[k];
  });
  if (key) return headers[key];
}
/**
 * 处理url中的参数 「:id」或「{id}」
 * @param url
 * @param pathParams
 * @returns {*}
 */

export function setUrlPathParams(url, pathParams) {
  if (!url) return url;
  if (!url.includes(':') || !url.includes('{')) return url;
  var urls = url.split('/');
  return urls.map(function (item) {
    if (!item.startsWith(':') && !item.startsWith('{')) return item;
    var key = item.replace(':', '').replace('{', '').replace('}', ''); // 如果参数不是object 直接将params作为value

    if (_typeof(pathParams) !== 'object') {
      var _value = pathParams; // @ts-ignore
      // eslint-disable-next-line no-param-reassign

      pathParams = null;
      return _value;
    }

    if (!(key in pathParams)) throw Error("\u7F3A\u5C11\u300C".concat(key, "\u300D\u53C2\u6570")); // @ts-ignore

    return pathParams[key];
  }).join('/');
}
/**
 * 修复因为从excel复制粘贴导致的特殊字符
 * @param obj
 */

export function fixObjectU202D(obj) {
  if (!obj) return obj;
  if (Array.isArray(obj)) return obj;
  if (_typeof(obj) !== 'object') return obj;
  loopObject(obj, function (ob, key, value) {
    if (value && typeof value === 'string') {
      // @ts-ignore
      ob[key] = fixU202D(value);
    }
  });
  return obj;
}
/**
 * 修复因为从excel复制粘贴导致的特殊字符
 * @param obj
 */

export function objectSpaceUnicodeToASCII(obj) {
  if (!obj) return obj;
  if (Array.isArray(obj)) return obj;
  if (_typeof(obj) !== 'object') return obj;
  loopObject(obj, function (ob, key, value) {
    if (value && typeof value === 'string') {
      // @ts-ignore
      ob[key] = spaceUnicodeToASCII(value);
    }
  });
  return obj;
}
export function spaceUnicodeToASCII(str) {
  if (typeof str !== 'string') return str;
  return decodeURIComponent(encodeURIComponent(str).replace(/%C2%A0/g, '%20'));
}
export function fixU202D(str) {
  if (!str) return str;
  if (typeof str !== 'string') return str;
  return str.replace(/[\u200b-\u200f\uFEFF\u202a-\u202e]/g, '');
}