var __defProp = Object.defineProperty;
var __getOwnPropDesc = Object.getOwnPropertyDescriptor;
var __getOwnPropNames = Object.getOwnPropertyNames;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __export = (target, all) => {
  for (var name in all)
    __defProp(target, name, { get: all[name], enumerable: true });
};
var __copyProps = (to, from, except, desc) => {
  if (from && typeof from === "object" || typeof from === "function") {
    for (let key of __getOwnPropNames(from))
      if (!__hasOwnProp.call(to, key) && key !== except)
        __defProp(to, key, { get: () => from[key], enumerable: !(desc = __getOwnPropDesc(from, key)) || desc.enumerable });
  }
  return to;
};
var __toCommonJS = (mod) => __copyProps(__defProp({}, "__esModule", { value: true }), mod);

// src/utils.ts
var utils_exports = {};
__export(utils_exports, {
  cloneDeep: () => cloneDeep,
  emptyObject: () => emptyObject,
  fixObjectU202D: () => fixObjectU202D,
  fixU202D: () => fixU202D,
  getContentType: () => getContentType,
  getFileName: () => getFileName,
  isObject: () => isObject,
  loopObject: () => loopObject,
  objectSpaceUnicodeToASCII: () => objectSpaceUnicodeToASCII,
  setDefaults: () => setDefaults,
  setObjectUndefinedToNull: () => setObjectUndefinedToNull,
  setPublicLoading: () => setPublicLoading,
  setUrlPathParams: () => setUrlPathParams,
  spaceUnicodeToASCII: () => spaceUnicodeToASCII,
  trimObject: () => trimObject
});
module.exports = __toCommonJS(utils_exports);
function setPublicLoading(fn, loading) {
  if (!fn)
    return;
  const setLoading = fn;
  if (!setLoading.__count)
    setLoading.__count = 0;
  if (loading) {
    setLoading(true);
    setLoading.__count += 1;
    return;
  }
  setLoading.__count -= 1;
  if (setLoading.__count === 0)
    setLoading(false);
}
function setDefaults(defaults, instance) {
  const ajaxInstance = instance;
  Object.entries(defaults).forEach(([key, value]) => {
    const oldValue = ajaxInstance.defaults[key];
    if (typeof value === "object" && oldValue) {
      if (Array.isArray(value)) {
        ajaxInstance.defaults[key] = [...oldValue, ...value];
      } else {
        ajaxInstance.defaults[key] = { ...oldValue, ...value };
      }
    } else {
      ajaxInstance.defaults[key] = value;
    }
  });
}
function getFileName(headers) {
  var _a;
  if (!headers)
    return;
  if (headers.filename)
    return headers.filename;
  if (headers.fileName)
    return headers.fileName;
  if (headers["file-name"])
    return headers["file-name"];
  const contentDisposition = headers["content-disposition"];
  if (!contentDisposition)
    return;
  if (contentDisposition.includes("filename*=")) {
    const fileNameUnicode = (_a = contentDisposition.split("filename*=")) == null ? void 0 : _a[1];
    if (fileNameUnicode) {
      return decodeURIComponent(fileNameUnicode.split("''")[1]);
    }
  }
  const filenameRegex = /filename[^;=\n]*=((['"]).*?\2|[^;\n]*)/;
  const matches = filenameRegex.exec(contentDisposition);
  if (matches != null && matches[1]) {
    return matches[1].replace(/['"]/g, "");
  }
}
function isObject(data) {
  if (!data)
    return false;
  if (typeof data !== "object")
    return false;
  if (typeof FormData !== "undefined" && data instanceof FormData)
    return false;
  return !Array.isArray(data);
}
function cloneDeep(data, hash = /* @__PURE__ */ new WeakMap()) {
  if (typeof data !== "object" || data === null) {
    throw new TypeError("\u4F20\u5165\u53C2\u6570\u4E0D\u662F\u5BF9\u8C61");
  }
  if (hash.has(data)) {
    return hash.get(data);
  }
  let newData = {};
  const dataKeys = Object.keys(data);
  dataKeys.forEach((value) => {
    const currentDataValue = data[value];
    if (typeof currentDataValue !== "object" || currentDataValue === null) {
      newData[value] = currentDataValue;
    } else if (Array.isArray(currentDataValue)) {
      newData[value] = [...currentDataValue];
    } else if (currentDataValue instanceof Set) {
      newData[value] = /* @__PURE__ */ new Set([...currentDataValue]);
    } else if (currentDataValue instanceof Map) {
      newData[value] = new Map([...currentDataValue]);
    } else {
      hash.set(data, data);
      newData[value] = cloneDeep(currentDataValue, hash);
    }
  });
  return newData;
}
function loopObject(data, deal) {
  if (typeof FormData !== "undefined" && data instanceof FormData)
    return data;
  if (typeof data !== "object")
    return data;
  if (data === null)
    return data;
  if (Array.isArray(data))
    return data.map((d) => loopObject(d, deal));
  const newData = cloneDeep(data);
  Object.entries(newData).forEach(([key, value]) => {
    if (typeof value === "object")
      return newData[key] = loopObject(value, deal);
    deal(newData, key, value);
  }, {});
  return newData;
}
function emptyObject(data) {
  return loopObject(data, (_data, key, value) => {
    if (["", null, void 0].includes(value)) {
      Reflect.deleteProperty(_data, key);
    }
  });
}
function setObjectUndefinedToNull(data) {
  return loopObject(data, (_data, key, value) => {
    if ([void 0].includes(value)) {
      _data[key] = null;
    }
  });
}
function trimObject(data) {
  return loopObject(data, (_data, key, value) => {
    _data[key] = typeof value === "string" ? value.trim() : value;
  });
}
function getContentType(headers) {
  if (!headers || typeof headers !== "object")
    return;
  const contentTypeKeys = ["Content-Type", "content-type", "contentType"];
  const key = contentTypeKeys.find((k) => !!headers[k]);
  if (key)
    return headers[key];
}
function setUrlPathParams(url, pathParams) {
  if (!url)
    return url;
  if (!url.includes(":") || !url.includes("{"))
    return url;
  const urls = url.split("/");
  return urls.map((item) => {
    if (!item.startsWith(":") && !item.startsWith("{"))
      return item;
    const key = item.replace(":", "").replace("{", "").replace("}", "");
    if (typeof pathParams !== "object") {
      const value = pathParams;
      pathParams = null;
      return value;
    }
    if (!(key in pathParams))
      throw Error(`\u7F3A\u5C11\u300C${key}\u300D\u53C2\u6570`);
    return pathParams[key];
  }).join("/");
}
function fixObjectU202D(obj) {
  if (!obj)
    return obj;
  if (Array.isArray(obj))
    return obj;
  if (typeof obj !== "object")
    return obj;
  loopObject(obj, (ob, key, value) => {
    if (value && typeof value === "string") {
      ob[key] = fixU202D(value);
    }
  });
  return obj;
}
function objectSpaceUnicodeToASCII(obj) {
  if (!obj)
    return obj;
  if (Array.isArray(obj))
    return obj;
  if (typeof obj !== "object")
    return obj;
  loopObject(obj, (ob, key, value) => {
    if (value && typeof value === "string") {
      ob[key] = spaceUnicodeToASCII(value);
    }
  });
  return obj;
}
function spaceUnicodeToASCII(str) {
  if (typeof str !== "string")
    return str;
  return decodeURIComponent(encodeURIComponent(str).replace(/%C2%A0/g, "%20"));
}
function fixU202D(str) {
  if (!str)
    return str;
  if (typeof str !== "string")
    return str;
  return str.replace(/[\u200b-\u200f\uFEFF\u202a-\u202e]/g, "");
}
// Annotate the CommonJS export names for ESM import in node:
0 && (module.exports = {
  cloneDeep,
  emptyObject,
  fixObjectU202D,
  fixU202D,
  getContentType,
  getFileName,
  isObject,
  loopObject,
  objectSpaceUnicodeToASCII,
  setDefaults,
  setObjectUndefinedToNull,
  setPublicLoading,
  setUrlPathParams,
  spaceUnicodeToASCII,
  trimObject
});
